package Polyze::HReject;
use Moose;
use Polyze::RRejectCleanup;
use Polyze::RRejectRCPT;
use Polyze::RRejectMilter;
use Polyze::HPostgreyAccept;
with 'Polyze::Handler';

sub scan_line {
   my ($self, $line) = @_;
   if ($line->text =~ m/ reject: RCPT /) {
      my $reject = $self->polyze->add_reporter(
         Polyze::RRejectRCPT->new(polyze => $self->polyze, line => $line),
      );
      if ("Greylist" eq $reject->reason && 1 == $reject->count) {
         # This is the first instance of a greylist rejection.  Add a
         # followup handler to look for an eventual acceptance of the
         # mail by postgrey.
         $self->polyze->push_handler(
            Polyze::HPostgreyAccept->new(
               polyze => $self->polyze,
               rreject => $reject,
            ),
         );
      }
   } elsif ($line->text =~ m[/cleanup.+: reject: ]) {
      $self->polyze->add_reporter(
         Polyze::RRejectCleanup->new(polyze => $self->polyze, line => $line),
      );
   } elsif ($line->text =~ m/: milter-reject: /) {
      $self->polyze->add_reporter(
         Polyze::RRejectMilter->new(polyze => $self->polyze, line => $line),
      );
   }
   return $Polyze::CONTINUE_LINE;
}

no Moose;
__PACKAGE__->meta->make_immutable;
