package Polyze::Handler;
use Moose::Role;

has polyze => (
   is => 'ro',
   isa => 'Polyze',
   required => 1,
   handles => [qw( day day_str )],
);

has isa_post_day_handler => (
   is => 'rw',
   isa => 'Bool',
   required => 0,
   default => 0,
);

has day_regex => (
   is => 'ro',
   isa => 'RegexpRef',
   required => 0,
   lazy => 1,
   builder => '_build_day_regex',
);

sub _build_day_regex {
   my ($self) = @_;
   my $day_str = $self->day_str;
   return qr/^$day_str /;
}

# Override this in a concrete handler.  The override should return one
# of the $Polyze::*_LINE constants.
#
sub scan_line {
   my ($self, $line) = @_;
   die("override missing");
}

no Moose;
1;
